; Splash Screen DLL
;   by QvasiModo (Mario Vilas)
;   27-Aug-03

; Source adapted to be built as a separated module. Use the WinAsm project
; file to build, or use the "makeit.bat" file.

include macros.inc
AppModel .386
include \masm32\include\windows.inc

; #########################################################################

; ---------------------------------------
; This are conditional assembly flags.
; Use FALSE to disable, TRUE to enable.
; ---------------------------------------

                        ;TRUE if you want to use a GIF or JPEG image
                        ; (IMAGE resource type) instead of a bitmap image
                        ; (BITMAP resource type).
SPLASH_USEIMAGE     equ TRUE

                        ;TRUE if you want to use region data.
SPLASH_USEREGION    equ TRUE

                        ;TRUE if you want the user to be able to close
                        ; the splash screen window by clicking on it.
SPLASH_ALLOWCLICK   equ FALSE

; ---------------------------------------
; This are constants used in the library.
; ---------------------------------------

                        ;How long to show splash window, in milliseconds.
                        ; Use INFINITE to disable the timer feature.
SPLASH_TIMEOUT      equ 1000

                        ;Splash window style bits.
                        ; At least WS_VISIBLE and WS_POPUP should be used.
SPLASH_STYLE        equ WS_VISIBLE or WS_POPUP or WS_EX_NOPARENTNOTIFY

                        ;Splash window extended style bits.
                        ; WS_EX_TOOLWINDOW should be used to prevent showing in title bar.
                        ; WS_EX_TRANSPARENT should only be used with region data.
                        ; WS_EX_TOPMOST can be used to stay always on top.
SPLASH_EXSTYLE      equ WS_EX_TOOLWINDOW

                        ;Splash window class style bits.
                        ; At least CS_NOCLOSE should be used.
SPLASH_CLASS        equ CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW or CS_NOCLOSE or CS_PARENTDC or CS_SAVEBITS

                        ;Your application's name. Will be shown in task manager on Win9X.
                        ; Use <> to disable this feature.
SPLASH_CAPTION      textequ <"Sample splash screen">

; #########################################################################

include SplashDll.inc   ;API definitions
include SplashProcs.inc ;Equates, structures, constants and data
include SplashProcs.Asm ;Main source code
end
