; Splash Screen DLL
;   by QvasiModo (Mario Vilas)
;   27-Aug-03

.code

; ---------------------------------------
; Exported functions
; ---------------------------------------

SplashOpen proc hWndParent

    .if hwin == 0
        invoke CreateEvent,0,0,0,0
        .if eax != 0
            mov hevent,eax
            push eax
            ife SPLASH_USEIMAGE
                invoke LoadBitmap,hinst,IDB_BITMAP1
            else
                invoke BitmapFromResource,hinst,IDI_IMAGE1
            endif
            .if eax != 0
                mov hbmp,eax
                invoke GetObject,eax,sizeof BITMAP,offset bitmap
                mov wc.hInstance,$invoke (GetModuleHandle,NULL)
                mov wc.hCursor,$invoke (LoadCursor,NULL,IDC_ARROW)
                invoke RegisterClass,offset wc
                ife SPLASH_USEREGION
                else
                    invoke FindResource,hinst,IDR_REGION1,RT_RCDATA
                    .if eax != NULL
                        invoke LoadResource,hinst,eax
                        .if eax != NULL
                            invoke LockResource,eax
                            .if eax != NULL
                                mov edx,[eax].RGNDATAHEADER.nRgnSize
                                add edx,sizeof RGNDATAHEADER
                                mov hrgn,$invoke (ExtCreateRegion,NULL,edx,eax)
                            .endif
                        .endif
                    .endif
                endif
                invoke CreateThread,0,0,offset Worker,0,0,offset thid
                .if eax != 0
                    mov hth,eax
                    invoke WaitForSingleObject,hevent,INFINITE
                .endif
                invoke CloseHandle,hevent
            .endif
            call CloseHandle
        .endif
    .endif
    mov eax,hwin
    ret

SplashOpen endp

SplashWait proc dwTimeout

    if SPLASH_TIMEOUT eq INFINITE
        ife SPLASH_ALLOWCLICK
            invoke SplashClose
        endif
    endif
    invoke WaitForSingleObject,hth,dwTimeout
    ret

SplashWait endp

SplashClose proc

    mov eax,hwin
    .if eax != 0
        invoke PostMessage,eax,WM_TIMER,0,0
    .endif
    ret

SplashClose endp

; ---------------------------------------
; Internally used functions
; ---------------------------------------

align DWORD
SplashProc proc hwnd,umsg,wparam,lparam
    local hdc   :dword
    local hold  :dword
    local ps    :PAINTSTRUCT

    mov eax,umsg
    .switch eax

    .break .if eax == WM_ERASEBKGND

    .case WM_PAINT
        invoke BeginPaint,hwnd,addr ps
        .break .if eax == 0
        mov hdc,$invoke (CreateCompatibleDC,eax)
        mov hold,$invoke (SelectObject,eax,hbmp)
        invoke BitBlt,ps.hdc,0,0,bitmap.bmWidth,bitmap.bmHeight,hdc,0,0,SRCCOPY
        invoke SelectObject,hdc,hold
        invoke DeleteDC,hdc
        invoke EndPaint,hwnd,addr ps
        .break

    ife SPLASH_ALLOWCLICK
    .case WM_TIMER
    else
    .case WM_TIMER, WM_LBUTTONUP, WM_RBUTTONUP
    endif
        invoke KillTimer,hwnd,wparam
        invoke PostMessage,hwnd,WM_DESTROY,0,0
        .break

    .case WM_CREATE
        if SPLASH_TIMEOUT ne INFINITE
            invoke SetTimer,hwnd,0,SPLASH_TIMEOUT,NULL
        endif
        ife SPLASH_USEREGION
        else
            mov eax,hrgn
            .break .if eax == NULL
            invoke SetWindowRgn,hwnd,eax,FALSE
        endif
        .breakdef

    .case WM_DESTROY
        mov hwin,0
        invoke DeleteObject,hbmp
        invoke DeleteObject,hrgn
        invoke DeleteObject,wc.hCursor
        invoke PostQuitMessage,0

    .default
        invoke DefWindowProc,hwnd,umsg,wparam,lparam
        ret

    .endswitch
    xor eax,eax
    ret

SplashProc endp

align DWORD
Worker proc lparam
    local msg   :MSG

    push NULL
    push wc.hInstance
    push NULL
    push HWND_DESKTOP
    push bitmap.bmHeight
    push bitmap.bmWidth 
    invoke GetSystemMetrics,SM_CYFULLSCREEN
    sub eax,bitmap.bmHeight
    sar eax,1
    push eax
    invoke GetSystemMetrics,SM_CXFULLSCREEN
    sub eax,bitmap.bmWidth
    sar eax,1
    push eax
    push SPLASH_STYLE
    ifb SPLASH_CAPTION
        push NULL
    else
        push offset szSplashCaption
    endif
    push offset szSplashClass
    push SPLASH_EXSTYLE
    call CreateWindowEx
    mov hwin,eax
    invoke SetEvent,hevent
    .if hwin != 0
        .repeat
            invoke GetMessage,addr msg,0,0,0
            inc eax
            .break .if zero?
            dec eax
            .break .if zero?
            invoke DispatchMessage,addr msg
        .until FALSE
    .endif
    ret

Worker endp
